<% echo "<br>creating econ4 database " . time() . "<hr>";

//This script creates a replicable database using data from two ms access tables popmail1 and foldertree
//After setting the parameters, it invokes "createReplicable.php3" to create the database and create the system 
//tables. It then creates a table "popmail", using $repsql to define the replication variables. It next inserts the
//popmail table into the "rep_tables" system table, so that the database knows that the table is replicable. It then
//imports records from access, and inserts them into popmail, setting a new key for each record, and preserving the 
//old key as oldid. This oldid is not actually used in this program.

//The second table "foldertree" is defined in a similar way. However, the id of "foldertree" records are used as
//foreign keys both in the "foldertree" table and in the "popmail" table, so we must locate all the keys that
//reference the "foldertree" and rewrite them replacing the oldid's with the newid's. The "checked" field is used 
//to check off which records in "foldertree" have had their keys rewritten. We also create a table "items"
//that identifies the newid's of some special folders and rewrite some filters to replace references to oldid's with
//variable names.

//When you are all done, you can drop the temporary columns oldid and checked if you like.

$connect = "localhost";
$user = "someuser";
$pass = "somepassword";
$db = "some database";

include "replication/createReplicable.php3";
include "replication/fixsql.php3";
include "replication/getkey.php3";

$oconn = odbc_connect ("Addresses", "", "");

$sql = "CREATE TABLE popmail (" . $repsql . ", xfrom varchar(255), subject varchar(255), date varchar(255), message text, status varchar(12), folder bigint, xto text, replyto varchar(255), cc text, bcc text, inbox tinyint, attachments tinyint,";

$sql = $sql . " sendattachments tinyint, sdate datetime, thread bigint, rootthread tinyint, html int, oldid bigint, checked tinyint default 0, INDEX (xfrom), INDEX (subject), INDEX (status), INDEX (folder), INDEX (sdate), INDEX (thread), INDEX (oldid))";

mysql_query($sql, $conn);

$sql = "INSERT INTO rep_tables (name) VALUES ('popmail')";
mysql_query($sql, $conn);

$sql = "SELECT * FROM popmail1 ORDER BY Sdate DESC";
$RS = odbc_exec($oconn, $sql);
$notEOF = odbc_fetch_row($RS, 1);
$ii = 1;
while ($notEOF){
	$new_key = getkey($conn);
	$vars = "(rep_db, id, xfrom, subject, date, message, status, folder, xto, replyto, cc, bcc, inbox, attachments, sendattachments, sdate, thread, rootthread, html, oldid)";
	$vals = "(0, " . $new_key . ", '" . fxs(odbc_result($RS, "from")) . "', '" . fxs(odbc_result($RS, "subject")) . "', '" . odbc_result($RS, "date") . "', '" . fxs(odbc_result($RS, "message")) . "',' " . odbc_result($RS, "status") . "', ";
	$vals = $vals . odbc_result($RS, "folder") . ", '" . fxs(odbc_result($RS, "to"))  . "', '" . fxs(odbc_result($RS, "reply-to"))  . "', '" . odbc_result($RS, "cc") . "', '" . odbc_result($RS, "bcc") . "', " . odbc_result($RS, "inbox") . ", " . odbc_result($RS, "attachments") . ", " . odbc_result($RS, "sendattachments") . ", '" . odbc_result($RS, "sdate") . "', " . odbc_result($RS, "thread") . ", " . odbc_result($RS, "rootthread") . ", " . odbc_result($RS, "html") . ", " . odbc_result($RS, "id") . ")";
	$sql = "INSERT INTO popmail " . $vars . " VALUES " . $vals;
	mysql_query($sql, $conn);
	$notEOF = odbc_fetch_row($RS);
	$ii ++;
	if($ii>100)$notEOF = false;
}

$sql = "CREATE TABLE foldertree (" . $repsql . ", orderby bigint, parent bigint, name varchar(50), filter varchar(255) default 'None', directory varchar(255), journal varchar(50), mobile tinyint, oldid bigint, checked tinyint default 0, INDEX(orderby, parent, id))";

mysql_query($sql, $conn);

$sql = "INSERT INTO rep_tables (name) VALUES ('foldertree')";
mysql_query($sql, $conn);

$sql = "CREATE TABLE items (" . $repsql . ", xkey varchar(50), comment varchar(255), INDEX(xkey))";
mysql_query($sql, $conn);

$sql = "INSERT INTO rep_tables (name) VALUES ('items')";
mysql_query($sql, $conn);

$sql = "SELECT * FROM foldertree";
$RS = odbc_exec($oconn, $sql);
$notEOF = odbc_fetch_row($RS, 1);
while ($notEOF){
	$new_key = getkey($conn);
	$filter = odbc_result($RS, "filter");
	$filter = str_replace("Status", "status", $filter);
	$filter = str_replace("Folder", "folder", $filter);
	$filter = str_replace("Inbox", "inbox", $filter);
	$filter = str_replace("41", "%trash%", $filter);
	$filter = str_replace("40", "%outbox%", $filter);
	$filter = str_replace("folder = 1", "folder = %inbox%", $filter);
	$vars = "(rep_db, id, orderby, parent, name, filter, directory, journal, mobile, oldid)";
	$vals = "(0, ". $new_key . ", " . odbc_result($RS, "orderby") . ", " . odbc_result($RS, "parent") . ", '" . odbc_result($RS, "name") . "', '" . $filter . "', '" . odbc_result($RS, "directory") . "', '" . odbc_result($RS, "journal") . "', " . odbc_result($RS, "mobile") . ", " . odbc_result($RS, "folder") . ")";
	$sql = "INSERT INTO foldertree " . $vars . " VALUES " . $vals;
	mysql_query($sql, $conn);
	$sql = "";
	if(odbc_result($RS, "name")=="Inbox") $sql = "INSERT INTO items (xkey, rep_db, id , comment) VALUES ('Inbox', 0, ";
	if(odbc_result($RS, "name")=="Outbox") $sql = "INSERT INTO items (xkey, rep_db, id, comment) VALUES ('Outbox', 0, ";
	if(odbc_result($RS, "name")=="Trash") $sql = "INSERT INTO items (xkey, rep_db, id, comment) VALUES ('Trash', 0, ";
	if ($sql <> ""){
		$item_key = getkey($conn);
		$sql = $sql . $item_key . ", " . $new_key . ")";
		mysql_query($sql, $conn);
	}
	$notEOF = odbc_fetch_row($RS);
}

$sql = "SELECT id, oldid FROM popmail";
$result = mysql_query($sql, $conn);
while($row = mysql_fetch_array($result)) {
	$sql = "SELECT id FROM popmail WHERE checked = 0 AND thread = " . $row["oldid"];
	$next= mysql_query($sql, $conn);
	while($nrow = mysql_fetch_array($next)) {
		$sql = "UPDATE popmail SET checked = 1, thread = " . $row["id"] . " WHERE id = " . $nrow["id"];
		mysql_query($sql, $conn);
	}
}

$sql = "UPDATE popmail SET checked = 0";
mysql_query($sql, $conn);
$sql = "SELECT id, oldid FROM foldertree";
$result = mysql_query($sql, $conn);
while($row = mysql_fetch_array($result)) {
	$sql = "SELECT id FROM foldertree WHERE checked = 0 AND parent = " . $row["oldid"];
	$next= mysql_query($sql, $conn);
	while($nrow = mysql_fetch_array($next)) {
		$sql = "UPDATE foldertree SET checked = 1, parent = " . $row["id"]. " WHERE id = " . $nrow["id"];
		mysql_query($sql, $conn);
	}
	$sql = "SELECT id FROM popmail WHERE checked = 0 AND folder = " . $row["oldid"];
	$next = mysql_query($sql, $conn);
	while($nrow = mysql_fetch_array($next)) {
		$sql = "UPDATE popmail SET checked = 1, folder = " . $row["id"]. " WHERE id = " . $nrow["id"];
		mysql_query($sql, $conn);
	}
}

mysql_close($conn);

%>






